'08/08/17 Plugin For Posting HDMI status

Function Custom_Initialize(msgPort As Object, userVariables As Object, bsp as Object)

   ' print "Custom_Initialize - entry"
   ' print "type of msgPort is ";type(msgPort)
    'print "type of userVariables is ";type(userVariables)

    Custom = newCustom(msgPort, userVariables, bsp)
	
    return Custom

End Function


Function newCustom(msgPort As Object, userVariables As Object, bsp as Object)
	
	print "initCustom 08/08/2017 13:29 "

	' Create the object to return and set it up
	
	s = {}
	s.msgPort = msgPort
	s.userVariables = userVariables
	s.bsp = bsp
	s.ProcessEvent = Custom_ProcessEvent
	s.objectName = "POST_Plugin_object"
	s.PostURL = "https://requestb.in/1nb4yyq1"
	s.sTime = createObject("roSystemTime")
	s.PlayerInfo = CreateObject("roDeviceInfo")
	s.HandleTimerEvent = HandleTimerEvent
	s.custom_zonemessage = custom_zonemessage
	s.CheckHDMIStatus = CheckHDMIStatus
	s.StartUpdateTimer = StartUpdateTimer
	s.POSTStatus = POSTStatus

	s.StartUpdateTimer()
	
	return s

End Function

	
Function Custom_ProcessEvent(event As Object) as boolean

	retval = false
    'print "Custom_ProcessEvent - entry"
    'print "type of m is ";type(m)
    'print "type of event is ";type(event)
	

	if type(event) = "roUrlEvent" then
		'retval = HandlePluginURLEvent(event, m)
	end if
	
	if type(event) = "roTimerEvent" then
		retval = HandleTimerEvent(event, m)
		
	else if	type(event) = "roAudioEvent" then
		'retval = HandlePluginAudioEvent(event, m)
	end if
	
	return retval

End Function
	



Function HandleTimerEvent(origMsg as Object, Custom as Object) as boolean

	if type(origMsg) = "roTimerEvent" then
	
		timerIdentity = origMsg.GetSourceIdentity()
		
		if Custom.UpdateSNMPTimer.GetIdentity() = origMsg.GetSourceIdentity() then
		
			Custom.CheckHDMIStatus()
			Custom.StartUpdateTimer()
			
		end if
		
	end if
	
End Function	


Function StartUpdateTimer()
	
	newTimeout = m.sTime.GetLocalDateTime()
	newTimeout.AddSeconds(10)
	m.UpdateSNMPTimer = CreateObject("roTimer")
	m.UpdateSNMPTimer.SetPort(m.msgPort)	
	m.UpdateSNMPTimer.SetDateTime(newTimeout)
	m.UpdateSNMPTimer.Start()
	
	'stop

End Function



Sub custom_zonemessage(msg$ as String)
	' send ZoneMessage message
	zoneMessageCmd = CreateObject("roAssociativeArray")
	zoneMessageCmd["EventType"] = "SEND_ZONE_MESSAGE"
	zoneMessageCmd["EventParameter"] = msg$
	m.msgPort.PostMessage(zoneMessageCmd)
End Sub


Function CheckHDMIStatus()As boolean

	HDMIStatus = invalid
	statusStr = ""
	
	' m.bsp.videomode

	if m.bsp.videomode <> invalid then
		'HDMIStatus = m.vm.GetHdmiOutputStatus().["output_present"]
		
		HDMIStatus = m.bsp.videomode.GetHdmiOutputStatus()
		
		if HDMIStatus <> invalid then 
			HDMIStatus = m.bsp.videomode.GetHdmiOutputStatus().["output_powered"]
			
			if HDMIStatus then
				'print " @@@  output_powered, true @@@ "
				statusStr = "Monitor is Connected AND ON"
			end if
		
		else 
			'print " @@@  output_powered, false @@@ "
			statusStr = "Monitor is Disconnected OR OFF"
			HDMIStatus = false
		end if 

		
	end if 
	
	posted = m.POSTStatus(statusStr)
	
	return HDMIStatus
	
End Function



Function POSTStatus(StatusStr As string)As Boolean

	m.PostStatusToServer = invalid
	
	if type(m.PostStatusToServer) <> "roUrlTransfer" then
	
		m.PostStatusToServer = CreateObject("roUrlTransfer")
        m.PostStatusToServer.SetUrl(m.PostURL)
        m.PostStatusToServer.SetPort(m.msgPort)
		m.PostStatusToServer.SetTimeout(900000)
		
	endif
	
	m.PostStatusToServer.AddHeader("TheHDMIStatus", StatusStr)
	
	ok = m.PostStatusToServer.AsyncPostFromString(StatusStr)
    if not ok then
		print " @@@  AsyncPostFromString failed @@@ "
    endif
	
	return ok

End Function

